﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.IdentityModel.Clients.ActiveDirectory;
using System.Threading.Tasks;
using System.Net.Http;
using System.Collections.Specialized;
using Newtonsoft.Json;
using System.Web.Security;

namespace PBIWebApp
{
 /* NOTE: This sample is to illustrate how to authenticate a Power BI web app. 
 * In a production application, you should provide appropriate exception handling and refactor authentication settings into 
 * a configuration. Authentication settings are hard-coded in the sample to make it easier to follow the flow of authentication. */
    public partial class _Default : Page
    {
        public AuthenticationResult authResult { get; set; }
        string baseUri = "https://api.powerbi.com/beta/myorg/";

        protected void Page_Load(object sender, EventArgs e)
        {
            //Test for AuthenticationResult
            if (Session["authResult"] != null)
            {
                //Get the authentication result from the session
                authResult = (AuthenticationResult)Session["authResult"];
                
                //Set user and toek from authentication result
                userLabel.Text = Session["user"].ToString();
                accessTokenTextbox.Text = authResult.AccessToken;
            }

            else
            {
                FormsAuthentication.RedirectToLoginPage();
            }
        }

    

        protected void getReportsButton_Click(object sender, EventArgs e)
        {
            string responseContent = string.Empty;
            //Configure datasets request
            System.Net.WebRequest request = System.Net.WebRequest.Create(String.Format("{0}reports", baseUri)) 
                as System.Net.HttpWebRequest;
            request.Method = "GET";
            request.ContentLength = 0;
            request.Headers.Add("Authorization", String.Format("Bearer {0}", authResult.AccessToken));

            //Get datasets response from request.GetResponse()
            using (var response = request.GetResponse() as System.Net.HttpWebResponse)
            {
                //Get reader from response stream
                using (var reader = new System.IO.StreamReader(response.GetResponseStream()))
                {
                    responseContent = reader.ReadToEnd();

                    //Deserialize JSON string
                    PBIReports PBIReports = JsonConvert.DeserializeObject<PBIReports>(responseContent);

                    tb_reportsResult.Text = string.Empty;
                    //Get each Dataset from 
                    foreach (PBIReport rpt in PBIReports.value)
                    {
                        //https://wabi-staging-us-east-redirect.analysis.windows.net
                        tb_reportsResult.Text += String.Format("{0}\t{1}\t{2}\n", rpt.id, rpt.name, 
                            "https://app.powerbi.com/reportEmbed?reportId="+rpt.id);

                        //tb_reportsResult.Text += String.Format("{0}\t{1}\t{2}\n", rpt.id, rpt.name, rpt.embedUrl); -- [TL] as of now, the link doesn't work because embedUrl uses embedReport while it should be reportEmbed
                    }
                }
            }
        }
    }
    
  
    public class PBIReports
    {
        public PBIReport[] value { get; set; }
    }
    public class PBIReport
    {
        public string id { get; set; }

        // the name of this property will change to 'displayName' when the API moves from Beta to V1 namespace
        public string name { get; set; }

        public string webUrl { get; set; }

        public string embedUrl { get; set; } 

    }




}